-module(fib).

% Exports both functions, now both can be called as fib:main() and
% fib:fibonacci(X).
-export([main/0, fibonacci/1, fibonacci_tail/1, fibonacci_dist/1,fibonacci_dist/2]).

% Implement Fibonacci computation directly inefficiently
% Implement the tail recursive Fibonacci ?
% Implement the direct inefficient computation by spawning subprocs
fibonacci(0) -> 1;
fibonacci(1) -> 1;
fibonacci(N) ->
  fibonacci(N-1) + fibonacci(N-2).

fibonacci_tail(N) when N < 2->
  fibonacci(N);
fibonacci_tail(N) -> fibonacci_tail(1,1,1,N).
fibonacci_tail(_Prev,Curr,Num,Target) when Num == Target -> Curr;
fibonacci_tail(Prev,Curr,Num,Target) -> fibonacci_tail(Curr,Prev+Curr,Num+1,Target).

fibonacci_dist(N) ->
  Me = self(),
  spawn(?MODULE,fibonacci_dist,[N,Me]),
  receive
    Res -> ok
  end,
  Res.
fibonacci_dist(N,Parent) when N < 2 ->
  Parent ! 1;
fibonacci_dist(N,Parent) ->fibo
  Me = self(),
  spawn(?MODULE,fibonacci_dist,[N-1,Me]),
  spawn(?MODULE,fibonacci_dist,[N-2,Me]),
  receive   
    Res1 -> ok
  end,
  receive 
    Res2 -> ok
  end,
  Parent ! Res1 + Res2.

main() ->
    fibonacci_dist(2).
