-module(pingpong).
-export([main/0,ping/0,pong/0]).

% Simple ping function:
%   Receives a PID of the calling process,
%   Prints "ping"
%   Sends a message (its own PID) to the pong process
%   Wait for another message.

ping() ->
    receive From ->
        io:format("ping~n"),
        timer:sleep(1000),
        From ! self(),
              ping()
    end.


% Same as ping(), but prints "pong" instead.
pong() ->
    receive From ->
        io:format("pong~n"),
        timer:sleep(1000),
        From ! self(),
              pong()
    end.

main() ->
    % Spawns the processes.
    Ping = spawn(fun ping/0),
    Pong = spawn(fun pong/0),
    % Sends the PID of Pong to the Ping process to initiate the ping-pong printouts.
    Ping ! Pong.
