-module(server).
-export([main/0,multiply/2,add/2,subtract/2,count/0,square/1]).

% If we don't want to keep track of all PIDs, we can bind a PID to an atom like
% this. We can then use it when calling the process.
start_server() ->
    Pid = spawn(fun() -> server(0) end),
    catch unregister(server),
    register(server, Pid).


% Initial math server, can multiply, add and subtract, square
server(N) ->
    receive 
%        { Command, From, Ref, Arg1, ..., Argn } -> ok,
        { count, From, Ref } -> Res = N;
        { mul, From, Ref, Num1, Num2 } -> Res = Num1 * Num2;
        { add, From, Ref, Num1, Num2 } -> Res = Num1 + Num2;
        { sub, From, Ref, Num1, Num2 } -> Res = Num1 - Num2;
        { square, From, Ref, Num } -> Res = Num* Num
    end,
    From ! { answer, Ref, Res },    
    server(N+1).

multiply(X,Y) ->
    Ref = make_ref(),
    server ! { mul, self(), Ref, X, Y },
    receive { answer, Ref , An } -> An end.

add(X,Y) ->
    Ref = make_ref(),
    server ! { add, self(), Ref, X, Y },
    receive { answer, Ref , An } -> An end.

subtract(X,Y) ->
    Ref = make_ref(),
    server ! { sub, self(), Ref, X, Y },
    receive { answer, Ref , An } -> An end.

square(X) ->
    Ref = make_ref(),
    server ! { square, self(), Ref, X },
    receive { answer, Ref, An } -> An end.

count() ->
    Ref = make_ref(),
    server ! { count, self(), Ref },
    receive { answer, Ref, An } -> An end.

main() ->
    start_server(),
    square(multiply(3,4)).   

