-module(server_genserver).
-export([main/0,multiply/2,add/2,subtract/2,square/1,count/0,start_server/0,stop_server/0]).
%-import(genserver,[start/3,request/2,stop/1]).

% We have our server become a genserver (read genserver.erl to see the
% implementation)
start_server() ->
    genserver:start(server,0,fun my_handler/2).

% The server loop. Now no recursion, it looks like an ordinary function
my_handler(N,{count}) ->
    { reply, N, N };
my_handler(N,{mul, Num1, Num2}) ->
    { reply, Num1 * Num2, N+2};
my_handler(N,{add,Num1, Num2}) ->
    { reply, Num1 + Num2, N+1};
my_handler(N,{sub,Num1, Num2}) ->
    { reply, Num1 - Num2, N};
my_handler(N,{square, Num }) ->
    { reply, Num * Num, N+2}.

multiply(X,Y) ->
    genserver:request(server,{mul, X, Y}).

add(X,Y) ->
    genserver:request(server,{add, X, Y}).

subtract(X,Y) ->
    genserver:request(server,{sub, X, Y}).

square(X) ->
    genserver:request(server,{square, X}).

count() ->
    genserver:request(server,{count}).

stop_server() ->
    genserver:stop(server).

main() ->
    start_server(),
    multiply(3,square(2)).
